pipeline {
    agent any
    environment {
        TERM = 'xterm' // Set the TERM environment variable to avoid the error
    }
    stages {
        stage('Checkout') {
            steps {
                checkout([$class: 'GitSCM',
                    branches: [[name: '*/main']],
                    extensions: [],
                    userRemoteConfigs: [[credentialsId: 'jenkins-gitlab',
                        url: 'git@gitlab.com:garsaa.sofiene/tp-15-full-stack-springboot-angular']]])
            }
        }

        stage('Build Project') {
            steps {
                dir('/var/lib/jenkins/workspace/tp15_full_stack_springboot_angular/spring-boot-oauth2-social-login') {
                    sh 'mvn clean install' // Execute the Maven command to build the project
                }
            }
        }

        stage('Build docker image MySQL') {
            steps {
                script {
                    docker.build("soft2023/mysql:5.6", "-f Dockerfile.MySQL .")
                }
            }
        }

        stage('Build docker image backendspring') {
    steps {
        
           script {
                    docker.build("soft2023/mybackend-spring-boot", "-f Dockerfilespring .")
       
    }
    }
}


        stage('Build docker image frontend-angular') {
            steps {
                script {
                   
                    docker.build("soft2023/myfrontend-angular", "-f Dockerfileangular .")
                }
            }
        }

        stage('Push to Docker Hub') {
            steps {
                withCredentials([string(credentialsId: 'docker-hub-credentials', variable: 'DOCKER_HUB_TOKEN')]) {
                    script {
                        def dockerHubToken = env.DOCKER_HUB_TOKEN
                        sh """
                            docker login --username=soft2023 --password="${dockerHubToken}"
                            docker push soft2023/mysql:5.6
                            docker push soft2023/myfrontend-angular
                            docker push soft2023/mybackend-spring-boot
                        """
                    }
                }
            }
        }

        stage('Copy Kubernetes manifests using Ansible') {
            steps {
                ansiblePlaybook(
                    becomeUser: 'jenkins',
                    credentialsId: 'jenkins-user_jenkins',
                    disableHostKeyChecking: true,
                    installation: 'ansible',
                    inventory: 'inventory.yml',
                    playbook: 'copy-manifests-playbook.yml'
                )
            }
        }

        stage('Apply Kubernetes manifests') {
            steps {
                ansiblePlaybook(
                    becomeUser: 'jenkins',
                    credentialsId: 'jenkins-user_jenkins',
                    disableHostKeyChecking: true,
                    installation: 'ansible',
                    inventory: 'inventory.yml',
                    playbook: 'apply-manifests-playbook.yml'
                )
            }
        }
    }
}
